with Service_Ready;
with Ada.Text_IO; use Ada.Text_IO;

package body Customer is

   task body Customer_T is
      use Customers;
      Outcome :          Boolean;
      --  every task instance, once elaborated, will know
      --+ its own specific numeric identity
      Self    : constant String  := Counter_T'Image (My_Id);
   begin
      Put_Line ("Customer " & Self & " walks in.");
      --  the customer checks whether there is a place
      --+ in the line waiting for service
      Customers.Signal (Outcome);
      if Outcome then
         --  if there is place in line, then the customer
         --+ takes a seat to wait his/her turn for service
         Service_Ready.Wait;
         --  after service, the customer leaves the shop
         Put_Line ("Serviced customer " & Self & " walks out.");
      else
         --  if there was no place to sit the customer
         --+ leaves unserviced
         Put_Line ("Customer " & Self & " leaves unserviced.");
      end if;
   end Customer_T;

end Customer;
