package body Customers is

   protected body Status is

      --  this procedure is executed in mutual exclusion
      --+ but only when its guard evaluates to true
      entry Wait when Present is
      begin
         In_Line := In_Line - 1;
         --  at any change in status, the guard must be updated
         Present := In_Line > 0;
      end Wait;

      --  this procedure is also executed in mutual exclusion
      procedure Signal (Outcome :    out Boolean) is
      begin
         In_Line := In_Line + 1;
         --  at any change in status, the guard must be updated
         Present := In_Line > 0;
         Outcome := True;
      exception
         --  when one customer too many tries to enter the
         --+ shop queue an exception is raised to disallow it
         when Constraint_Error =>
            Outcome := False;
      end Signal;

   end Status;

end Customers;
