package Customers is

   --  we use a modulo-type, bounded to Limit
   --+ to assign numeric identities to customer tasks
   Limit : constant Positive := 100_000;
   type Counter_T is mod Limit;

   --  the barber shop has only "Chairs" chairs
   Chairs : constant Natural := 5;
   subtype Max_In_Line is Natural range 0 .. Chairs;

   protected Status is
      entry Wait;
      procedure Signal (Outcome : out Boolean);
   private
      --  initially the shop is empty and there is
      --+ no customer is line
      In_Line : Max_In_Line := 0;
      Present : Boolean := False;
   end Status;

   procedure Wait renames Status.Wait;
   procedure Signal (Outcome : out Boolean) renames Status.Signal;

end Customers;
