with Barber;
with Customer;
with Customers; use Customers;

with System;

procedure Sleeping_Barber is
   use Customer;
   pragma Priority (15);
   --  we assign a numeric identifier to each new customer
   Customer_Id       :          Counter_T             := Counter_T'First;
   --  and a priority *lower* than the main unit
   Customer_Priority :          System.Priority       := 10;
   --  we then use a variable to assign (in overwriting mode)
   --+ references to newly created instances of Customer_T tasks
   A_Customer        :          Customer.Customer_Ref;
   --  finally, we insert a voluntary suspension in between
   --+ successive iterations
   Interval          : constant Duration              := 2.0;
begin
   loop
      Customer_Id := Customer_Id + 1;
      A_Customer := new Customer.Customer_T (Customer_Id,
                                             Customer_Priority);
      --  we interject a suspension interval in between
      --+ the creation of any two successive customers
      delay Interval;
   end loop;
end Sleeping_Barber;
